Package org.apache.cxf.helpers

# Class IOUtils

java.lang.Object
org.apache.cxf.helpers.IOUtils

public final class IOUtils extends Object

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final int`
  `DEFAULT_BINARY_MAX_SIZE`
  `static final int`
  `DEFAULT_BUFFER_SIZE`
  `static final Charset`
  `UTF8_CHARSET`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static void`
  `consume(InputStream in)`
  `static void`
  `consume(InputStream input, int atLeast)`
  Consumes at least the given number of bytes from the input stream
  `static int`
  `copy(InputStream input, OutputStream output)`
  `static int`
  `copy(InputStream input, OutputStream output, int bufferSize)`
  `static int`
  `copy(InputStream input, OutputStream output, int bufferSize, int maxSize)`
  `static void`
  `copy(Reader input, Writer output, int bufferSize)`
  `static int`
  `copyAndCloseInput(InputStream input, OutputStream output)`
  `static int`
  `copyAndCloseInput(InputStream input, OutputStream output, int bufferSize)`
  `static void`
  `copyAndCloseInput(Reader input, Writer output)`
  `static void`
  `copyAndCloseInput(Reader input, Writer output, int bufferSize)`
  `static void`
  `copyAtLeast(InputStream input, OutputStream output, int atLeast)`
  Copy at least the specified number of bytes from the input to the output or until the inputstream is finished.
  `static void`
  `copyAtLeast(Reader input, Writer output, int atLeast)`
  `static boolean`
  `isEmpty(InputStream is)`
  `static ByteArrayInputStream`
  `loadIntoBAIS(InputStream in)`
  Load the InputStream into memory and return a ByteArrayInputStream that represents it.
  `static String`
  `newStringFromBytes(byte[] bytes)`
  Use this function instead of new String(byte[]) to avoid surprises from non-standard default encodings.
  `static String`
  `newStringFromBytes(byte[] bytes, int start, int length)`
  Use this function instead of new String(byte[], int, int) to avoid surprises from non-standard default encodings.
  `static String`
  `newStringFromBytes(byte[] bytes, String charsetName)`
  Use this function instead of new String(byte[], String) to avoid surprises from non-standard default encodings.
  `static String`
  `newStringFromBytes(byte[] bytes, String charsetName, int start, int length)`
  Use this function instead of new String(byte[], int, int, String) to avoid surprises from non-standard default encodings.
  `static InputStream`
  `nullOrNotEmptyStream(InputStream is)`
  Checks if input stream is empty.
  `static byte[]`
  `readBytesFromStream(InputStream in)`
  Deprecated, for removal: This API element is subject to removal in a future version.
  use `readBytesFromStream(InputStream, int)`
  `static byte[]`
  `readBytesFromStream(InputStream in, int maxSize)`
  `static String`
  `readStringFromStream(InputStream in)`
  `static String`
  `toString(InputStream input)`
  `static String`
  `toString(InputStream input, int bufferSize)`
  `static String`
  `toString(InputStream input, int bufferSize, String charset)`
  `static String`
  `toString(InputStream input, String charset)`
  `static String`
  `toString(Reader input)`
  `static String`
  `toString(Reader input, int bufSize)`
  `static void`
  `transferTo(InputStream inputStream, File destinationFile)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### DEFAULT_BINARY_MAX_SIZE

    public static final int DEFAULT_BINARY_MAX_SIZE

  - ### UTF8_CHARSET

    public static final Charset UTF8_CHARSET

  - ### DEFAULT_BUFFER_SIZE

    public static final int DEFAULT_BUFFER_SIZE
    See Also:
      - Constant Field Values

- ## Method Details

  - ### nullOrNotEmptyStream

    public static InputStream nullOrNotEmptyStream(InputStream is) throws IOException
    Checks if input stream is empty. If the standard InputStream means do not provide such details, the stream might be wrapped into PushbackInputStream and is going to be returned instead of original one.
    Parameters:
      `is` - input stream to check
    Returns:
      "null" if original input stream is empty, otherwise original stream or original stream wrapped into PushbackInputStream.
    Throws:
      `IOException`

  - ### isEmpty

    public static boolean isEmpty(InputStream is) throws IOException
    Throws:
      `IOException`

  - ### newStringFromBytes

    public static String newStringFromBytes(byte[] bytes, String charsetName)
    Use this function instead of new String(byte[], String) to avoid surprises from non-standard default encodings.
    Parameters:
      `bytes` -
      `charsetName` -

  - ### newStringFromBytes

    public static String newStringFromBytes(byte[] bytes)
    Use this function instead of new String(byte[]) to avoid surprises from non-standard default encodings.
    Parameters:
      `bytes` -

  - ### newStringFromBytes

    public static String newStringFromBytes(byte[] bytes, String charsetName, int start, int length)
    Use this function instead of new String(byte[], int, int, String) to avoid surprises from non-standard default encodings.
    Parameters:
      `bytes` -
      `charsetName` -
      `start` -
      `length` -

  - ### newStringFromBytes

    public static String newStringFromBytes(byte[] bytes, int start, int length)
    Use this function instead of new String(byte[], int, int) to avoid surprises from non-standard default encodings.
    Parameters:
      `bytes` -
      `start` -
      `length` -

  - ### copy

    public static int copy(InputStream input, OutputStream output) throws IOException
    Throws:
      `IOException`

  - ### copyAndCloseInput

    public static int copyAndCloseInput(InputStream input, OutputStream output) throws IOException
    Throws:
      `IOException`

  - ### copyAndCloseInput

    public static int copyAndCloseInput(InputStream input, OutputStream output, int bufferSize) throws IOException
    Throws:
      `IOException`

  - ### copyAndCloseInput

    public static void copyAndCloseInput(Reader input, Writer output) throws IOException
    Throws:
      `IOException`

  - ### copyAndCloseInput

    public static void copyAndCloseInput(Reader input, Writer output, int bufferSize) throws IOException
    Throws:
      `IOException`

  - ### copy

    public static int copy(InputStream input, OutputStream output, int bufferSize) throws IOException
    Throws:
      `IOException`

  - ### copy

    public static int copy(InputStream input, OutputStream output, int bufferSize, int maxSize) throws IOException
    Throws:
      `IOException`

  - ### copyAtLeast

    public static void copyAtLeast(InputStream input, OutputStream output, int atLeast) throws IOException
    Copy at least the specified number of bytes from the input to the output or until the inputstream is finished.
    Parameters:
      `input` -
      `output` -
      `atLeast` -
    Throws:
      `IOException`

  - ### copyAtLeast

    public static void copyAtLeast(Reader input, Writer output, int atLeast) throws IOException
    Throws:
      `IOException`

  - ### copy

    public static void copy(Reader input, Writer output, int bufferSize) throws IOException
    Throws:
      `IOException`

  - ### transferTo

    public static void transferTo(InputStream inputStream, File destinationFile) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(InputStream input) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(InputStream input, String charset) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(InputStream input, int bufferSize) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(InputStream input, int bufferSize, String charset) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(Reader input) throws IOException
    Throws:
      `IOException`

  - ### toString

    public static String toString(Reader input, int bufSize) throws IOException
    Throws:
      `IOException`

  - ### readStringFromStream

    public static String readStringFromStream(InputStream in) throws IOException
    Throws:
      `IOException`

  - ### loadIntoBAIS

    public static ByteArrayInputStream loadIntoBAIS(InputStream in) throws IOException
    Load the InputStream into memory and return a ByteArrayInputStream that represents it. Closes the in stream.
    Parameters:
      `in` -
    Throws:
      `IOException`

  - ### consume

    public static void consume(InputStream in) throws IOException
    Throws:
      `IOException`

  - ### consume

    public static void consume(InputStream input, int atLeast) throws IOException
    Consumes at least the given number of bytes from the input stream
    Parameters:
      `input` -
      `atLeast` -
    Throws:
      `IOException`

  - ### readBytesFromStream

    @Deprecated(forRemoval=true) public static byte[] readBytesFromStream(InputStream in) throws IOException
    Deprecated, for removal: This API element is subject to removal in a future version.
    use `readBytesFromStream(InputStream, int)`
    Throws:
      `IOException`

  - ### readBytesFromStream

    public static byte[] readBytesFromStream(InputStream in, int maxSize) throws IOException
    Throws:
      `IOException`